# Class OjLegendBase

This is the base class for oj-legend WebElement, and is generated from the component's metadata. Do not modify these contents since they'll be replaced during the next generation. Put overrides into the WebElements's subclass, OjLegend.ts.

#### Hierarchy

- OjWebElement
  - OjLegendBase
    - OjLegend

#####
Index

### Constructors

constructor

### Methods

changeExpanded
changeHiddenCategories
changeHighlightedCategories
clear
click
findElement
findElements
getAs
getAttribute
getCssValue
getDrilling
getExpanded
getHalign
getHiddenCategories
getHideAndShowBehavior
getHighlightedCategories
getHoverBehavior
getHoverBehaviorDelay
getLocation
getOrientation
getProperty
getRect
getScrolling
getSectionTitleHalign
getSectionTitleStyle
getSections
getSize
getSymbolHeight
getSymbolWidth
getText
getTextStyle
getTrackResize
getTranslations
getValign
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady

## Constructors

### constructor

- new OjLegendBase(el, locators): OjLegendBase

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjLegendBase

  Inherited from OjWebElement.constructor

## Methods

### changeExpanded

- changeExpanded(expanded): Promise<void>

- Sets the value of `expanded` property. Specifies the key set containing the ids of sections that should be expanded on initial render. See the Help documentation for more information.

  #### Parameters

  - ##### expanded: null

    The value to set for `expanded`

  #### Returns Promise<void>

  #### Deprecated

  Since 16.0.0. Collapsible legend sections are not recommended in the Redwood theme.

### changeHiddenCategories

- changeHiddenCategories(hiddenCategories): Promise<void>

- Sets the value of `hiddenCategories` property. An array of categories that will be hidden.

  #### Parameters

  - ##### hiddenCategories: string[]

    The value to set for `hiddenCategories`

  #### Returns Promise<void>

### changeHighlightedCategories

- changeHighlightedCategories(highlightedCategories): Promise<void>

- Sets the value of `highlightedCategories` property. An array of categories that will be highlighted.

  #### Parameters

  - ##### highlightedCategories: string[]

    The value to set for `highlightedCategories`

  #### Returns Promise<void>

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.clear

### click

- click(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.click

### findElement

- findElement(locator): WebElementPromise

- #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  #### Inherit Doc

  Inherited from OjWebElement.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  #### Inherit Doc

  Inherited from OjWebElement.findElements

### getAs

- getAs(): Promise<string>

- Gets the value of `as` property. An alias for the '$current' context variable passed to slot content for the nodeTemplate slot.

  #### Returns Promise<string>

  The value of `as` property.

  #### Deprecated

  Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

### getAttribute

- getAttribute(attributeName): Promise<string>

- #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getAttribute

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getCssValue

### getDrilling

- getDrilling(): Promise<string>

- Gets the value of `drilling` property. Specifies whether drilling is enabled. Drillable objects will show a pointer cursor on hover and fire an ojDrill event on click. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `drilling` property.

### getExpanded

- getExpanded(): Promise<null>

- Gets the value of `expanded` property. Specifies the key set containing the ids of sections that should be expanded on initial render. See the Help documentation for more information.

  #### Returns Promise<null>

  The value of `expanded` property.

  #### Deprecated

  Since 16.0.0. Collapsible legend sections are not recommended in the Redwood theme.

### getHalign

- getHalign(): Promise<string>

- Gets the value of `halign` property. Defines the horizontal alignment of the legend contents.

  #### Returns Promise<string>

  The value of `halign` property.

### getHiddenCategories

- getHiddenCategories(): Promise<string[]>

- Gets the value of `hiddenCategories` property. An array of categories that will be hidden.

  #### Returns Promise<string[]>

  The value of `hiddenCategories` property.

### getHideAndShowBehavior

- getHideAndShowBehavior(): Promise<string>

- Gets the value of `hideAndShowBehavior` property. Defines whether the legend can be used to initiate hide and show behavior on referenced data items.

  #### Returns Promise<string>

  The value of `hideAndShowBehavior` property.

### getHighlightedCategories

- getHighlightedCategories(): Promise<string[]>

- Gets the value of `highlightedCategories` property. An array of categories that will be highlighted.

  #### Returns Promise<string[]>

  The value of `highlightedCategories` property.

### getHoverBehavior

- getHoverBehavior(): Promise<string>

- Gets the value of `hoverBehavior` property. Defines the behavior applied when hovering over a legend item.

  #### Returns Promise<string>

  The value of `hoverBehavior` property.

### getHoverBehaviorDelay

- getHoverBehaviorDelay(): Promise<number>

- Gets the value of `hoverBehaviorDelay` property. Specifies initial hover delay in milliseconds for highlighting items in legend.

  #### Returns Promise<number>

  The value of `hoverBehaviorDelay` property.

  #### Deprecated

  Since 14.1.0. This is not recommended in the Redwood design system.

### getLocation

- getLocation(): Promise<ILocation>

- #### Returns Promise<ILocation>

  #### Inherit Doc

  Inherited from OjWebElement.getLocation

### getOrientation

- getOrientation(): Promise<string>

- Gets the value of `orientation` property. Defines the orientation of the legend, which determines the direction in which the legend items are laid out.

  #### Returns Promise<string>

  The value of `orientation` property.

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjWebElement.getProperty

### getRect

- getRect(): Promise<IRectangle>

- #### Returns Promise<IRectangle>

  #### Inherit Doc

  Inherited from OjWebElement.getRect

### getScrolling

- getScrolling(): Promise<string>

- Gets the value of `scrolling` property. Defines whether scrolling is enabled for the legend.

  #### Returns Promise<string>

  The value of `scrolling` property.

  #### Deprecated

  Since 12.1.0. Setting scrolling to off is not supported in the Redwood theme and it is not recommended.

### getSectionTitleHalign

- getSectionTitleHalign(): Promise<string>

- Gets the value of `sectionTitleHalign` property. The horizontal alignment of the section titles.

  #### Returns Promise<string>

  The value of `sectionTitleHalign` property.

### getSectionTitleStyle

- getSectionTitleStyle(): Promise<object>

- Gets the value of `sectionTitleStyle` property. The CSS style object defining the style of the section titles' text.

  #### Returns Promise<object>

  The value of `sectionTitleStyle` property.

### getSections

- getSections(): Promise<null | Sections[]>

- Gets the value of `sections` property. An array of objects specifying the legend sections.

  #### Returns Promise<null | Sections[]>

  The value of `sections` property.

### getSize

- getSize(): Promise<ISize>

- #### Returns Promise<ISize>

  #### Inherit Doc

  Inherited from OjWebElement.getSize

### getSymbolHeight

- getSymbolHeight(): Promise<number>

- Gets the value of `symbolHeight` property. The height of the legend symbol in pixels. See the Help documentation for more information.

  #### Returns Promise<number>

  The value of `symbolHeight` property.

### getSymbolWidth

- getSymbolWidth(): Promise<number>

- Gets the value of `symbolWidth` property. The width of the legend symbol in pixels. See the Help documentation for more information.

  #### Returns Promise<number>

  The value of `symbolWidth` property.

### getText

- getText(): Promise<string>

- #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getText

### getTextStyle

- getTextStyle(): Promise<object>

- Gets the value of `textStyle` property. The CSS style object defining the style of the legend item text.

  #### Returns Promise<object>

  The value of `textStyle` property.

### getTrackResize

- getTrackResize(): Promise<string>

- Gets the value of `trackResize` property. Defines whether the element will automatically render in response to changes in size. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `trackResize` property.

  #### Deprecated

  Since 15.0.0. This is no longer needed due to performance enhancements. The default behavior will be used.

### getTranslations

- getTranslations(): Promise<null | Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<null | Translations>

  The value of `translations` property.

### getValign

- getValign(): Promise<string>

- Gets the value of `valign` property. Defines the vertical alignment of the legend contents.

  #### Returns Promise<string>

  The value of `valign` property.

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  #### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  Inherited from OjWebElement.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  #### Returns Condition<Promise<boolean>>

  #### Deprecated

  Inherited from OjWebElement.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.sendKeys

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjWebElement.setProperty

### submit

- submit(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjWebElement.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjWebElement.whenReady

Generated using TypeDoc